diff --git a/framework/source/uielement/menubarmanager.cxx b/framework/source/uielement/menubarmanager.cxx
index feb5e71..e4a65f4 100644
--- a/framework/source/uielement/menubarmanager.cxx
+++ b/framework/source/uielement/menubarmanager.cxx
@@ -536,12 +536,12 @@ void MenuBarManager::RemoveListener()
             MenuItemHandler* pItemHandler = *p;
             if ( pItemHandler->xMenuItemDispatch.is() )
             {
-                URL aTargetURL;
-                aTargetURL.Complete = pItemHandler->aMenuItemURL;
-                m_xURLTransformer->parseStrict( aTargetURL );
+                URL aURL;
+                aURL.Complete = pItemHandler->aMenuItemURL;
+                m_xURLTransformer->parseStrict( aURL );
 
                 pItemHandler->xMenuItemDispatch->removeStatusListener(
-                    static_cast< XStatusListener* >( this ), aTargetURL );
+                    static_cast< XStatusListener* >( this ), aURL );
             }
 
             pItemHandler->xMenuItemDispatch.clear();
@@ -624,17 +624,17 @@ void SAL_CALL MenuBarManager::disposing( const EventObject& Source ) throw ( Run
     if ( pMenuItemDisposing )
     {
         // Release references to the dispatch object
-        URL aTargetURL;
-        aTargetURL.Complete = pMenuItemDisposing->aMenuItemURL;
+        URL aURL;
+        aURL.Complete = pMenuItemDisposing->aMenuItemURL;
 
         // Check reference of service manager before we use it. Reference could
         // be cleared due to RemoveListener call!
         if ( m_xContext.is() )
         {
-            m_xURLTransformer->parseStrict( aTargetURL );
+            m_xURLTransformer->parseStrict( aURL );
 
             pMenuItemDisposing->xMenuItemDispatch->removeStatusListener(
-                static_cast< XStatusListener* >( this ), aTargetURL );
+                static_cast< XStatusListener* >( this ), aURL );
             pMenuItemDisposing->xMenuItemDispatch.clear();
             if ( pMenuItemDisposing->xPopupMenu.is() )
             {
@@ -820,7 +820,7 @@ IMPL_LINK( MenuBarManager, Activate, Menu *, pMenu, bool )
             }
         }
 
-        URL aTargetURL;
+        URL aURL;
 
         // Use provided dispatch provider => fallback to frame as dispatch provider
         Reference< XDispatchProvider > xDispatchProvider;
@@ -850,20 +850,20 @@ IMPL_LINK( MenuBarManager, Activate, Menu *, pMenu, bool )
                         {
                             Reference< XDispatch > xMenuItemDispatch;
 
-                            aTargetURL.Complete = pMenuItemHandler->aMenuItemURL;
+                            aURL.Complete = pMenuItemHandler->aMenuItemURL;
 
-                            m_xURLTransformer->parseStrict( aTargetURL );
+                            m_xURLTransformer->parseStrict( aURL );
 
                             if ( bHasDisabledEntries )
                             {
-                                if ( aCmdOptions.Lookup( SvtCommandOptions::CMDOPTION_DISABLED, aTargetURL.Path ))
+                                if ( aCmdOptions.Lookup( SvtCommandOptions::CMDOPTION_DISABLED, aURL.Path ))
                                     pMenu->HideItem( pMenuItemHandler->nItemId );
                             }
 
                             if ( m_bIsBookmarkMenu )
-                                xMenuItemDispatch = xDispatchProvider->queryDispatch( aTargetURL, pMenuItemHandler->aTargetFrame, 0 );
+                                xMenuItemDispatch = xDispatchProvider->queryDispatch( aURL, pMenuItemHandler->aFrame, 0 );
                             else
-                                xMenuItemDispatch = xDispatchProvider->queryDispatch( aTargetURL, OUString(), 0 );
+                                xMenuItemDispatch = xDispatchProvider->queryDispatch( aURL, OUString(), 0 );
 
                             bool bPopupMenu( false );
                             if ( !pMenuItemHandler->xPopupMenuController.is() &&
@@ -885,14 +885,14 @@ IMPL_LINK( MenuBarManager, Activate, Menu *, pMenu, bool )
                             if ( xMenuItemDispatch.is() )
                             {
                                 pMenuItemHandler->xMenuItemDispatch = xMenuItemDispatch;
-                                pMenuItemHandler->aMenuItemURL      = aTargetURL.Complete;
+                                pMenuItemHandler->aMenuItemURL      = aURL.Complete;
 
                                 if ( !bPopupMenu )
                                 {
-                                    xMenuItemDispatch->addStatusListener( static_cast< XStatusListener* >( this ), aTargetURL );
-                                    // For the menubar, we have to keep status listening to support Ubuntu's HUD.
+                                    xMenuItemDispatch->addStatusListener( static_cast< XStatusListener* >( this ), aURL );
+                                    // for the menubar keep listening to support exempli gratia Ubuntu's HUD
                                     if ( !m_bHasMenuBar )
-                                        xMenuItemDispatch->removeStatusListener( static_cast< XStatusListener* >( this ), aTargetURL );
+                                        xMenuItemDispatch->removeStatusListener( static_cast< XStatusListener* >( this ), aURL );
                                 }
                             }
                             else if ( !bPopupMenu )
@@ -910,13 +910,13 @@ IMPL_LINK( MenuBarManager, Activate, Menu *, pMenu, bool )
                         // We need an update to reflect the current state
                         try
                         {
-                            aTargetURL.Complete = pMenuItemHandler->aMenuItemURL;
-                            m_xURLTransformer->parseStrict( aTargetURL );
+                            aURL.Complete = pMenuItemHandler->aMenuItemURL;
+                            m_xURLTransformer->parseStrict( aURL );
 
                             pMenuItemHandler->xMenuItemDispatch->addStatusListener(
-                                                                    static_cast< XStatusListener* >( this ), aTargetURL );
+                                                                    static_cast< XStatusListener* >( this ), aURL );
                             pMenuItemHandler->xMenuItemDispatch->removeStatusListener(
-                                                                    static_cast< XStatusListener* >( this ), aTargetURL );
+                                                                    static_cast< XStatusListener* >( this ), aURL );
                         }
                         catch ( const Exception& )
                         {
@@ -967,7 +967,7 @@ IMPL_LINK_NOARG( MenuBarManager, AsyncSettingsHdl, Timer*, void)
 
 IMPL_LINK( MenuBarManager, Select, Menu *, pMenu, bool )
 {
-    URL                     aTargetURL;
+    URL                     aURL;
     Sequence<PropertyValue> aArgs;
     Reference< XDispatch >  xDispatch;
 
@@ -1009,8 +1009,8 @@ IMPL_LINK( MenuBarManager, Select, Menu *, pMenu, bool )
                 MenuItemHandler* pMenuItemHandler = GetMenuItemHandler( nCurItemId );
                 if ( pMenuItemHandler && pMenuItemHandler->xMenuItemDispatch.is() )
                 {
-                    aTargetURL.Complete = pMenuItemHandler->aMenuItemURL;
-                    m_xURLTransformer->parseStrict( aTargetURL );
+                    aURL.Complete = pMenuItemHandler->aMenuItemURL;
+                    m_xURLTransformer->parseStrict( aURL );
 
                     if ( m_bIsBookmarkMenu )
                     {
@@ -1029,7 +1029,7 @@ IMPL_LINK( MenuBarManager, Select, Menu *, pMenu, bool )
     if ( xDispatch.is() )
     {
         SolarMutexReleaser aReleaser;
-        xDispatch->dispatch( aTargetURL, aArgs );
+        xDispatch->dispatch( aURL, aArgs );
     }
 
     if ( !m_bHasMenuBar )
@@ -1044,7 +1044,7 @@ bool MenuBarManager::MustBeHidden( PopupMenu* pPopupMenu, const Reference< XURLT
 {
     if ( pPopupMenu )
     {
-        URL               aTargetURL;
+        URL               aURL;
         SvtCommandOptions aCmdOptions;
 
         sal_uInt16 nCount = pPopupMenu->GetItemCount();
@@ -1066,10 +1066,10 @@ bool MenuBarManager::MustBeHidden( PopupMenu* pPopupMenu, const Reference< XURLT
                 }
                 else
                 {
-                    aTargetURL.Complete = pPopupMenu->GetItemCommand( nId );
-                    rTransformer->parseStrict( aTargetURL );
+                    aURL.Complete = pPopupMenu->GetItemCommand( nId );
+                    rTransformer->parseStrict( aURL );
 
-                    if ( aCmdOptions.Lookup( SvtCommandOptions::CMDOPTION_DISABLED, aTargetURL.Path ))
+                    if ( aCmdOptions.Lookup( SvtCommandOptions::CMDOPTION_DISABLED, aURL.Path ))
                         ++nHideCount;
                 }
             }
@@ -1613,7 +1613,7 @@ void MenuBarManager::FillMenu(
      for ( sal_Int32 n = 0; n < rItemContainer->getCount(); n++ )
     {
         Sequence< PropertyValue >       aProp;
-        OUString                   aCommandURL;
+        OUString                   aActionURL;
         OUString                   aLabel;
         OUString                   aHelpURL;
         OUString                   aModuleIdentifier( rModuleIdentifier );
@@ -1631,8 +1631,14 @@ void MenuBarManager::FillMenu(
                 for ( int i = 0; i < aProp.getLength(); i++ )
                 {
                     OUString aPropName = aProp[i].Name;
-                    if ( aPropName == "CommandURL" )
-                        aProp[i].Value >>= aCommandURL;
+                    if ( aPropName == "ActionURL" )
+                        aProp[i].Value >>= aActionURL;
+                    else if ( aPropName == "CommandURL" )
+                    {
+                        SAL_WARN( "framework", "\"CommandURL\" to \"ActionURL\" in MenuBarManager::FillMenu" );
+                        aProp[i].Value >>= aActionURL;
+                        aProp[i].Name = "ActionURL";
+                    }
                     else if ( aPropName == "HelpURL" )
                         aProp[i].Value >>= aHelpURL;
                     else if ( aPropName == "ItemDescriptorContainer" )
@@ -1656,7 +1662,7 @@ void MenuBarManager::FillMenu(
                 if ( nType == css::ui::ItemType::DEFAULT )
                 {
                     pMenu->InsertItem( nId, aLabel );
-                    pMenu->SetItemCommand( nId, aCommandURL );
+                    pMenu->SetItemCommand( nId, aActionURL );
 
                     if ( nStyle )
                     {
@@ -1946,7 +1952,7 @@ void MenuBarManager::Init(const Reference< XFrame >& rFrame,Menu* pAddonMenu,boo
                 if ( pAddonAttributes )
                 {
                     // read additional attributes from attributes struct and AddonMenu implementation will delete all attributes itself!!
-                    pMenuItemHandler->aTargetFrame = pAddonAttributes->aTargetFrame;
+                    pMenuItemHandler->aFrame = pAddonAttributes->aFrame;
                 }
 
                 pMenuItemHandler->aMenuItemURL = aItemCommand;
diff --git a/framework/source/uielement/menubarmerger.cxx b/framework/source/uielement/menubarmerger.cxx
index 8adb19f..03e860b 100644
--- a/framework/source/uielement/menubarmerger.cxx
+++ b/framework/source/uielement/menubarmerger.cxx
@@ -396,8 +396,14 @@ void MenuBarMerger::GetMenuEntry(
             rAddonMenuEntry[i].Value >>= rAddonMenuItem.aURL;
         else if ( aMenuEntryPropName == ADDONSMENUITEM_STRING_TITLE )
             rAddonMenuEntry[i].Value >>= rAddonMenuItem.aTitle;
-        else if ( aMenuEntryPropName == ADDONSMENUITEM_STRING_TARGET )
-            rAddonMenuEntry[i].Value >>= rAddonMenuItem.aTarget;
+        else if ( aMenuEntryPropName == ADDONSMENUITEM_STRING_RECIPIENT )
+            rAddonMenuEntry[i].Value >>= rAddonMenuItem.aRecipient;
+        else if ( aMenuEntryPropName == "Target" )
+        {
+            SAL_WARN( "framework", "\"Target\" into \"Recipient\" in MenuBarMerger" );
+            rAddonMenuEntry[i].Value >>= rAddonMenuItem.aRecipient;
+            ///rAddonMenuEntry[i].Name = OUString::createFromAscii( ADDONSMENUITEM_STRING_RECIPIENT );
+        }
         else if ( aMenuEntryPropName == ADDONSMENUITEM_STRING_SUBMENU )
         {
             uno::Sequence< uno::Sequence< beans::PropertyValue > > aSubMenu;
diff --git a/framework/source/uielement/newmenucontroller.cxx b/framework/source/uielement/newmenucontroller.cxx
index 94b15fc..aa5d01d 100644
--- a/framework/source/uielement/newmenucontroller.cxx
+++ b/framework/source/uielement/newmenucontroller.cxx
@@ -307,7 +307,7 @@ NewMenuController::NewMenuController( const css::uno::Reference< css::uno::XComp
     m_bNewMenu( false ),
     m_bModuleIdentified( false ),
     m_bAcceleratorCfg( false ),
-    m_aTargetFrame( "_default" ),
+    m_aFrame( "_default" ),
     m_xContext( xContext )
 {
 }
@@ -331,10 +331,10 @@ void NewMenuController::fillPopupMenu( Reference< css::awt::XPopupMenu >& rPopup
     if ( pVCLPopupMenu )
     {
         Reference< XDispatchProvider > xDispatchProvider( m_xFrame, UNO_QUERY );
-        URL aTargetURL;
-        aTargetURL.Complete = rtl::OUString::createFromAscii(m_bNewMenu ? aSlotNewDocDirect : aSlotAutoPilot);
-        m_xURLTransformer->parseStrict( aTargetURL );
-        Reference< XDispatch > xMenuItemDispatch = xDispatchProvider->queryDispatch( aTargetURL, OUString(), 0 );
+        URL theURL;
+        theURL.Complete = rtl::OUString::createFromAscii(m_bNewMenu ? aSlotNewDocDirect : aSlotAutoPilot);
+        m_xURLTransformer->parseStrict( theURL );
+        Reference< XDispatch > xMenuItemDispatch = xDispatchProvider->queryDispatch( theURL, OUString(), 0 );
         if(xMenuItemDispatch == nullptr)
             return;
 
@@ -343,7 +343,7 @@ void NewMenuController::fillPopupMenu( Reference< css::awt::XPopupMenu >& rPopup
 
         OUString aTitle;
         OUString aURL;
-        OUString aTargetFrame;
+        OUString aRecipientFrame;
         OUString aImageId;
         sal_uInt16 nItemId = 1;
 
@@ -358,7 +358,7 @@ void NewMenuController::fillPopupMenu( Reference< css::awt::XPopupMenu >& rPopup
                 else if ( aProperty.Name == DYNAMICMENU_PROPERTYNAME_IMAGEIDENTIFIER )
                     aProperty.Value >>= aImageId;
                 else if ( aProperty.Name == DYNAMICMENU_PROPERTYNAME_TARGETNAME )
-                    aProperty.Value >>= aTargetFrame;
+                    aProperty.Value >>= aRecipientFrame;
             }
 
             if ( aTitle.isEmpty() && aURL.isEmpty() )
@@ -371,7 +371,7 @@ void NewMenuController::fillPopupMenu( Reference< css::awt::XPopupMenu >& rPopup
                 pVCLPopupMenu->InsertItem( nItemId, aTitle );
                 pVCLPopupMenu->SetItemCommand( nItemId, aURL );
 
-                sal_uIntPtr nAttributePtr = MenuAttributes::CreateAttribute( aTargetFrame, aImageId );
+                sal_uIntPtr nAttributePtr = MenuAttributes::CreateAttribute( aRecipientFrame, aImageId );
                 pVCLPopupMenu->SetUserValue( nItemId, nAttributePtr, MenuAttributes::ReleaseAttribute );
 
                 nItemId++;
@@ -419,7 +419,7 @@ void SAL_CALL NewMenuController::itemSelected( const css::awt::MenuEvent& rEvent
     xURLTransformer     = m_xURLTransformer;
     aLock.clear();
 
-    css::util::URL aTargetURL;
+    css::util::URL aURL;
     Sequence< PropertyValue > aArgsList( 1 );
 
     if ( xPopupMenu.is() && xDispatchProvider.is() )
@@ -427,24 +427,24 @@ void SAL_CALL NewMenuController::itemSelected( const css::awt::MenuEvent& rEvent
         VCLXPopupMenu* pPopupMenu = static_cast<VCLXPopupMenu *>(VCLXPopupMenu::GetImplementation( xPopupMenu ));
         if ( pPopupMenu )
         {
-            OUString aTargetFrame( m_aTargetFrame );
+            OUString aRecipientFrame( m_aFrame );
 
             {
                 SolarMutexGuard aSolarMutexGuard;
                 PopupMenu* pVCLPopupMenu = static_cast<PopupMenu *>(pPopupMenu->GetMenu());
-                aTargetURL.Complete = pVCLPopupMenu->GetItemCommand(rEvent.MenuId);
+                aURL.Complete = pVCLPopupMenu->GetItemCommand(rEvent.MenuId);
                 sal_uLong nAttributePtr = pVCLPopupMenu->GetUserValue(rEvent.MenuId);
                 MenuAttributes* pAttributes = reinterpret_cast<MenuAttributes *>(nAttributePtr);
                 if (pAttributes)
-                    aTargetFrame = pAttributes->aTargetFrame;
+                    aRecipientFrame = pAttributes->aFrame;
             }
 
-            xURLTransformer->parseStrict( aTargetURL );
+            xURLTransformer->parseStrict( aURL );
 
             aArgsList[0].Name = "Referer";
             aArgsList[0].Value = makeAny( OUString( "private:user" ));
 
-            xDispatch = xDispatchProvider->queryDispatch( aTargetURL, aTargetFrame, 0 );
+            xDispatch = xDispatchProvider->queryDispatch( aURL, aRecipientFrame, 0 );
         }
     }
 
@@ -455,7 +455,7 @@ void SAL_CALL NewMenuController::itemSelected( const css::awt::MenuEvent& rEvent
         // after select!!!
         NewDocument* pNewDocument = new NewDocument;
         pNewDocument->xDispatch  = xDispatch;
-        pNewDocument->aTargetURL = aTargetURL;
+        pNewDocument->aRecipientURL = aURL;
         pNewDocument->aArgSeq    = aArgsList;
         Application::PostUserEvent( LINK(nullptr, NewMenuController, ExecuteHdl_Impl), pNewDocument );
     }
@@ -559,7 +559,7 @@ IMPL_STATIC_LINK( NewMenuController, ExecuteHdl_Impl, void*, p, void )
         // Asynchronous execution as this can lead to our own destruction!
         // Framework can recycle our current frame and the layout manager disposes all user interface
         // elements if a component gets detached from its frame!
-        pNewDocument->xDispatch->dispatch( pNewDocument->aTargetURL, pNewDocument->aArgSeq );
+        pNewDocument->xDispatch->dispatch( pNewDocument->aRecipientURL, pNewDocument->aArgSeq );
     delete pNewDocument;
 }
 
diff --git a/framework/source/uielement/popuptoolbarcontroller.cxx b/framework/source/uielement/popuptoolbarcontroller.cxx
index e23f64c..6b25d59 100644
--- a/framework/source/uielement/popuptoolbarcontroller.cxx
+++ b/framework/source/uielement/popuptoolbarcontroller.cxx
@@ -609,7 +609,7 @@ throw ( css::uno::RuntimeException, std::exception )
     if ( !m_aLastURL.getLength() )
         return;
 
-    OUString aTarget( "_default" );
+    OUString aRecipient( "_default" );
     if ( m_xPopupMenu.is() )
     {
         // TODO investigate how to wrap Get/SetUserValue in css::awt::XMenu
@@ -626,14 +626,14 @@ throw ( css::uno::RuntimeException, std::exception )
                 pVCLPopupMenu->GetUserValue( pVCLPopupMenu->GetCurItemId() ) );
 
         if ( pMenuAttributes )
-            aTarget = pMenuAttributes->aTargetFrame;
+            aRecipient = pMenuAttributes->aFrame;
     }
 
     css::uno::Sequence< css::beans::PropertyValue > aArgs( 1 );
     aArgs[0].Name = "Referer";
     aArgs[0].Value <<= OUString( "private:user" );
 
-    dispatchCommand( m_aLastURL, aArgs, aTarget );
+    dispatchCommand( m_aLastURL, aArgs, aRecipient );
 }
 
 void NewToolbarController::functionExecuted( const OUString &rCommand )
diff --git a/framework/source/uielement/recentfilesmenucontroller.cxx b/framework/source/uielement/recentfilesmenucontroller.cxx
index 786ef69..c24a41d 100644
--- a/framework/source/uielement/recentfilesmenucontroller.cxx
+++ b/framework/source/uielement/recentfilesmenucontroller.cxx
@@ -49,7 +49,7 @@ static const char MENU_SHORTCUT[]     = "~N. ";
 
 struct LoadRecentFile
 {
-    util::URL                               aTargetURL;
+    util::URL                               aURL;
     uno::Sequence< beans::PropertyValue >   aArgSeq;
     uno::Reference< frame::XDispatch >      xDispatch;
 };
@@ -91,7 +91,7 @@ public:
     virtual void SAL_CALL itemActivated( const awt::MenuEvent& rEvent ) throw (uno::RuntimeException, std::exception) override;
 
     // XDispatchProvider
-    virtual uno::Reference< frame::XDispatch > SAL_CALL queryDispatch( const util::URL& aURL, const OUString& sTarget, sal_Int32 nFlags ) throw( uno::RuntimeException, std::exception ) override;
+    virtual uno::Reference< frame::XDispatch > SAL_CALL queryDispatch( const util::URL& aURL, const OUString& sRecipient, sal_Int32 nOptions ) throw( uno::RuntimeException, std::exception ) override;
 
     // XDispatch
     virtual void SAL_CALL dispatch( const util::URL& aURL, const uno::Sequence< beans::PropertyValue >& seqProperties ) throw( uno::RuntimeException, std::exception ) override;
@@ -271,7 +271,7 @@ void RecentFilesMenuController::executeEntry( sal_Int32 nIndex )
 {
     Reference< XDispatch >            xDispatch;
     Reference< XDispatchProvider >    xDispatchProvider;
-    css::util::URL                    aTargetURL;
+    css::util::URL                    aURL;
     Sequence< PropertyValue >         aArgsList;
 
     osl::ClearableMutexGuard aLock( m_aMutex );
@@ -283,8 +283,8 @@ void RecentFilesMenuController::executeEntry( sal_Int32 nIndex )
     {
         const RecentFile& rRecentFile = m_aRecentFilesItems[ nIndex ];
 
-        aTargetURL.Complete = rRecentFile.aURL;
-        m_xURLTransformer->parseStrict( aTargetURL );
+        aURL.Complete = rRecentFile.aURL;
+        m_xURLTransformer->parseStrict( aURL );
 
         sal_Int32 nSize = 2;
         aArgsList.realloc( nSize );
@@ -303,7 +303,7 @@ void RecentFilesMenuController::executeEntry( sal_Int32 nIndex )
             aArgsList[nSize-1].Value <<= m_aModuleName;
         }
 
-        xDispatch = xDispatchProvider->queryDispatch( aTargetURL, "_default", 0 );
+        xDispatch = xDispatchProvider->queryDispatch( aURL, "_default", 0 );
     }
 
     if ( xDispatch.is() )
@@ -313,7 +313,7 @@ void RecentFilesMenuController::executeEntry( sal_Int32 nIndex )
         // after select!!!
         LoadRecentFile* pLoadRecentFile = new LoadRecentFile;
         pLoadRecentFile->xDispatch  = xDispatch;
-        pLoadRecentFile->aTargetURL = aTargetURL;
+        pLoadRecentFile->aURL = aURL;
         pLoadRecentFile->aArgSeq    = aArgsList;
 
         Application::PostUserEvent( LINK(nullptr, RecentFilesMenuController, ExecuteHdl_Impl), pLoadRecentFile );
@@ -388,8 +388,8 @@ void RecentFilesMenuController::impl_setPopupMenu()
 // XDispatchProvider
 Reference< XDispatch > SAL_CALL RecentFilesMenuController::queryDispatch(
     const URL& aURL,
-    const OUString& /*sTarget*/,
-    sal_Int32 /*nFlags*/ )
+    const OUString& /*sRecipient*/,
+    sal_Int32 /*nOptions*/ )
 throw( RuntimeException, std::exception )
 {
     osl::MutexGuard aLock( m_aMutex );
@@ -446,7 +446,7 @@ IMPL_STATIC_LINK( RecentFilesMenuController, ExecuteHdl_Impl, void*, p, void )
         // Asynchronous execution as this can lead to our own destruction!
         // Framework can recycle our current frame and the layout manager disposes all user interface
         // elements if a component gets detached from its frame!
-        pLoadRecentFile->xDispatch->dispatch( pLoadRecentFile->aTargetURL, pLoadRecentFile->aArgSeq );
+        pLoadRecentFile->xDispatch->dispatch( pLoadRecentFile->aURL, pLoadRecentFile->aArgSeq );
     }
     catch ( const Exception& )
     {
diff --git a/framework/source/uielement/resourcemenucontroller.cxx b/framework/source/uielement/resourcemenucontroller.cxx
index 02011c7..414d4e4 100644
--- a/framework/source/uielement/resourcemenucontroller.cxx
+++ b/framework/source/uielement/resourcemenucontroller.cxx
@@ -272,7 +272,7 @@ void ResourceMenuController::fillToolbarData()
         {
             if ( m_xMenuContainer->getByIndex( i ) >>= aPropSequence )
             {
-                OUString aCommandURL;
+                OUString aActionURL;
                 OUString aLabel;
                 sal_uInt16 nType = css::ui::ItemType::DEFAULT;
                 bool bVisible = true;
@@ -280,7 +280,14 @@ void ResourceMenuController::fillToolbarData()
                 for ( const auto& aProp: aPropSequence )
                 {
                     if ( aProp.Name == "CommandURL" )
-                        aProp.Value >>= aCommandURL;
+                    {
+                        SAL_WARN( "framework", "\"CommandURL\" to \"ActionURL\" in fillToolbarData()" );
+                        aProp.Value >>= aActionURL;
+                        ///aProp.Name = "ActionURL";
+                    }
+
+                    if ( aProp.Name == "ActionURL" )
+                        aProp.Value >>= aActionURL;
                     else if ( aProp.Name == "Label" )
                         aProp.Value >>= aLabel;
                     else if ( aProp.Name == "Type" )
@@ -295,7 +302,7 @@ void ResourceMenuController::fillToolbarData()
                     if ( bVisible )
                     {
                         pVCLMenu->InsertItem( m_nNewMenuId, aLabel );
-                        pVCLMenu->SetItemCommand( m_nNewMenuId++, aCommandURL );
+                        pVCLMenu->SetItemCommand( m_nNewMenuId++, aActionURL );
                     }
                     break;
                 case css::ui::ItemType::SEPARATOR_LINE:
diff --git a/framework/source/uielement/statusbarmanager.cxx b/framework/source/uielement/statusbarmanager.cxx
index fce91ae..15501f0 100644
--- a/framework/source/uielement/statusbarmanager.cxx
+++ b/framework/source/uielement/statusbarmanager.cxx
@@ -55,7 +55,7 @@
 using namespace ::com::sun::star;
 
 // Property names of a menu/menu item ItemDescriptor
-static const char ITEM_DESCRIPTOR_COMMANDURL[]  = "CommandURL";
+static const char ITEM_DESCRIPTOR_ACTIONURL[]   = "ActionURL";
 static const char ITEM_DESCRIPTOR_HELPURL[]     = "HelpURL";
 static const char ITEM_DESCRIPTOR_OFFSET[]      = "Offset";
 static const char ITEM_DESCRIPTOR_STYLE[]       = "Style";
@@ -308,19 +308,19 @@ void StatusBarManager::CreateControllers()
         if ( nId == 0 )
             continue;
 
-        OUString aCommandURL( m_pStatusBar->GetItemCommand( nId ));
+        OUString aActionURL( m_pStatusBar->GetItemCommand( nId ));
         bool bInit( true );
         uno::Reference< frame::XStatusbarController > xController;
         AddonStatusbarItemData *pItemData = static_cast< AddonStatusbarItemData *>( m_pStatusBar->GetItemData( nId ) );
         uno::Reference< ui::XStatusbarItem > xStatusbarItem(
-            static_cast< cppu::OWeakObject *>( new StatusbarItem( m_pStatusBar, pItemData, nId, aCommandURL ) ),
+            static_cast< cppu::OWeakObject *>( new StatusbarItem( m_pStatusBar, pItemData, nId, aActionURL ) ),
             uno::UNO_QUERY );
 
         beans::PropertyValue aPropValue;
         std::vector< uno::Any > aPropVector;
 
-        aPropValue.Name     = "CommandURL";
-        aPropValue.Value    <<= aCommandURL;
+        aPropValue.Name     = "ActionURL";
+        aPropValue.Value    <<= aActionURL;
         aPropVector.push_back( uno::makeAny( aPropValue ) );
 
         aPropValue.Name     = "ModuleIdentifier";
@@ -353,10 +353,10 @@ void StatusBarManager::CreateControllers()
 
         // 1) UNO Statusbar controllers, registered in Controllers.xcu
         if ( m_xStatusbarControllerFactory.is() &&
-             m_xStatusbarControllerFactory->hasController( aCommandURL, m_aModuleIdentifier ))
+             m_xStatusbarControllerFactory->hasController( aActionURL, m_aModuleIdentifier ))
         {
             xController.set(m_xStatusbarControllerFactory->createInstanceWithArgumentsAndContext(
-                                aCommandURL, aArgs, m_xContext ),
+                                aActionURL, aArgs, m_xContext ),
                             uno::UNO_QUERY );
             bInit = false; // Initialization is done through the factory service
         }
@@ -366,7 +366,7 @@ void StatusBarManager::CreateControllers()
             svt::StatusbarController* pController( nullptr );
 
             // 2) Old SFX2 Statusbar controllers
-            pController = CreateStatusBarController( m_xFrame, m_pStatusBar, nId, aCommandURL );
+            pController = CreateStatusBarController( m_xFrame, m_pStatusBar, nId, aActionURL );
             if ( !pController )
             {
                 // 3) Is Add-on? Generic statusbar controller
@@ -380,7 +380,7 @@ void StatusBarManager::CreateControllers()
                 else
                 {
                     // 4) Default Statusbar controller
-                    pController = new svt::StatusbarController( m_xContext, m_xFrame, aCommandURL, nId );
+                    pController = new svt::StatusbarController( m_xContext, m_xFrame, aActionURL, nId );
                 }
             }
 
@@ -427,7 +427,7 @@ void StatusBarManager::FillStatusBar( const uno::Reference< container::XIndexAcc
     for ( sal_Int32 n = 0; n < rItemContainer->getCount(); n++ )
     {
         uno::Sequence< beans::PropertyValue >   aProp;
-        OUString                                aCommandURL;
+        OUString                                aActionURL;
         OUString                                aHelpURL;
         sal_Int16                               nOffset( 0 );
         sal_Int16                               nStyle( 0 );
@@ -440,9 +440,15 @@ void StatusBarManager::FillStatusBar( const uno::Reference< container::XIndexAcc
             {
                 for ( int i = 0; i < aProp.getLength(); i++ )
                 {
-                    if ( aProp[i].Name == ITEM_DESCRIPTOR_COMMANDURL )
+                    if ( aProp[i].Name == ITEM_DESCRIPTOR_ACTIONURL )
                     {
-                        aProp[i].Value >>= aCommandURL;
+                        aProp[i].Value >>= aActionURL;
+                    }
+                    else if ( aProp[i].Name == "CommandURL" )
+                    {
+                        SAL_WARN( "framework", "\"CommandURL\" to \"ActionURL\" in FillStatusBar" );
+                        aProp[i].Value >>= aActionURL;
+                        aProp[i].Name == ITEM_DESCRIPTOR_ACTIONURL;
                     }
                     else if ( aProp[i].Name == ITEM_DESCRIPTOR_HELPURL )
                     {
@@ -466,13 +472,13 @@ void StatusBarManager::FillStatusBar( const uno::Reference< container::XIndexAcc
                     }
                 }
 
-                if (( nType == css::ui::ItemType::DEFAULT ) && !aCommandURL.isEmpty() )
+                if (( nType == css::ui::ItemType::DEFAULT ) && !aActionURL.isEmpty() )
                 {
-                    OUString aString( vcl::CommandInfoProvider::Instance().GetLabelForCommand(aCommandURL, m_xFrame));
+                    OUString aString( vcl::CommandInfoProvider::Instance().GetLabelForCommand( aActionURL, m_xFrame ));
                     StatusBarItemBits nItemBits( impl_convertItemStyleToItemBits( nStyle ));
 
                     m_pStatusBar->InsertItem( nId, nWidth, nItemBits, nOffset );
-                    m_pStatusBar->SetItemCommand( nId, aCommandURL );
+                    m_pStatusBar->SetItemCommand( nId, aActionURL );
                     m_pStatusBar->SetAccessibleName( nId, aString );
                     ++nId;
                 }
